Vagrant.configure(2) do |config|
  config.vm.box = "bento/ubuntu-18.04"
  
  config.vm.provision "shell", inline: <<-SHELL
  wget https://apt.puppetlabs.com/puppet5-release-$(lsb_release -cs).deb
  dpkg -i puppet5-release-$(lsb_release -cs).deb
  apt-get -qq update
  apt-get install -y puppet-agent
  SHELL

  config.vm.define "appserver" do |appserver|
    appserver.vm.hostname = "appserver"
  end

  config.vm.define "dbserver" do |dbserver|
    dbserver.vm.hostname = "dbserver"
  end

  config.vm.define "web" do |web|
    web.vm.hostname = "web"
    web.vm.network "forwarded_port", guest: 80, host: 8080
  end

  config.vm.define "tst0" do |tst0|
    tst0.vm.hostname = "tst0"
  end

  config.vm.define "tst1" do |tst1|
    tst1.vm.hostname = "tst1"
  end

  config.vm.define "tst2" do |tst2|
    tst2.vm.hostname = "tst2"
  end

  config.vm.define "redis" do |redis|
    redis.vm.hostname = "redis"
  end 
  
  config.vm.provision "puppet" do |puppet|
    puppet.manifests_path = "./manifests"
    puppet.manifest_file = "default.pp"
  end
end


# Stages: main and last 
## main - all vms
## last - redis to extract ips of each vm and store in local db
# Query redis from vm to get ip of another vm